/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  DSManager.cpp: Direct Sound Manager

  (c) 2005 Jimbo and Off Topic Productions
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


#include "DXOgg.h"


IDirectSound8 *dSound;
IDirectSoundBuffer *dSoundPBuffer;

float GlobalMusicVolume;


BOOL InitDirectSound()
{
    WAVEFORMATEX wfe;
    DSBUFFERDESC dsbd;

    memset(&dsbd, 0, sizeof(DSBUFFERDESC));
    dsbd.dwSize = sizeof(DSBUFFERDESC);
    dsbd.dwFlags = DSBCAPS_PRIMARYBUFFER | DSBCAPS_CTRLVOLUME;

    memset(&wfe, 0, sizeof(wfe));
    wfe.cbSize = sizeof(WAVEFORMATEX);
    wfe.nChannels = 2;
    wfe.wBitsPerSample = 16;
    wfe.nBlockAlign = (wfe.nChannels*wfe.wBitsPerSample)/8;
    wfe.wFormatTag = WAVE_FORMAT_PCM;

    wfe.nSamplesPerSec = 44100;

    wfe.nAvgBytesPerSec = (wfe.nSamplesPerSec*wfe.nBlockAlign);

    HWND hwndDeusExWindow = NULL;

    FString windowClassName;

    windowClassName = appPackage();
    windowClassName += TEXT("UnrealWWindowsViewportWindow");

    hwndDeusExWindow = FindWindow((TCHAR*)windowClassName.GetCharArray().GetData(), NULL);

    bFoundWindow = (hwndDeusExWindow != NULL);

    if(!bFoundWindow)
        return FALSE;

    if(DirectSoundCreate8(NULL, &dSound, NULL) != DS_OK)
    {
        debugf(TEXT("DXOgg: DXOgg, class DSManager: Could not create the dSound Object"));
        return FALSE;
    }
    if(dSound->SetCooperativeLevel((HWND)hwndDeusExWindow, DSSCL_PRIORITY) != DS_OK)
    {
        dSound->Release();
        debugf(TEXT("DXOgg: DSDriver: Could not set the dSound primary cooperation level"));
        return FALSE;
    }
    if(dSound->CreateSoundBuffer(&dsbd, &dSoundPBuffer, NULL) != DS_OK)
    {
        dSound->Release();
        debugf(TEXT("DXOgg: DSDriver: Could not create the dSound primary buffer"));
        return FALSE;
    }
    if(dSoundPBuffer->SetFormat(&wfe) != DS_OK)
    {
        dSoundPBuffer->Release();
        dSound->Release();
        debugf(TEXT("DXOgg: DSDriver: Could not set the dSoundPBuffer primary buffer format"));
        return FALSE;
    }

    debugf(TEXT("DXOgg: Initialized"));

    return TRUE;
}

void DestroyDirectSound()
{
    if(dSoundPBuffer)
        dSoundPBuffer->Release();
    if(dSound)
        dSound->Release();

    debugf(TEXT("DXOgg: Terminated"));
}

