/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  DXOgg.cpp:  Ogg Player for Deus Ex

  (c) 2005 Jimbo and Off Topic Productions
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



//PREPARE FOR THE MOST SLOPPY CODE EVER!
//(I blame Hanh.  and unreal.)


#include "DXOgg.h"

IMPLEMENT_DXOGG_PACKAGE();
IMPLEMENT_CLASS(ADXOgg);

#define NAMES_ONLY
#define AUTOGENERATE_NAME(name) SAMPLENATIVEPACKAGE_API FName SAMPLENATIVEPACKAGE_##name;
#define AUTOGENERATE_FUNCTION(cls,idx,name) IMPLEMENT_FUNCTION(cls,idx,name)
#include "DXOggClasses.h"
#undef AUTOGENERATE_FUNCTION
#undef AUTOGENERATE_NAME
#undef NAMES_ONLY


HANDLE      hInstMain;

DWORD       dwClassRefs = 0;

BYTE        oldHookData[5];
BYTE        newHookData[5];
DWORD       mainVolumeAddress;

BOOL        bDirectSoundInitialized = FALSE;

OggStream*  currentStream = NULL;

float       transitionTime = 0.0f;
float       transitionSpeed = 0.0f;
BOOL        bFadingIn = FALSE;
BOOL        bArghIHaveToWaitForTheWindowToOpenBeforeICanDoAnythingIBlameTimSweenyOrCarone = FALSE;
BOOL        bWaitingToPlaySong = FALSE;
BOOL        bFoundWindow = FALSE;

FString     oggPath;
FString     nextOggFileIntro;
FString     nextOggFileLoop;
float       nextPlayPos;


LPVOID WINAPI GetTrueProcAddress(HMODULE hMod, LPCSTR lpFunc);
LPVOID WINAPI GetTrueProcAddress(HMODULE hMod, LPCSTR lpFunc)
{
    LPVOID bla = GetProcAddress(hMod, lpFunc);

    if(!bla) return NULL;

    if(*(LPBYTE)bla == 0x68)
        bla = (LPVOID)*(LPDWORD)((DWORD)bla + 1);

    return bla;
}

BOOL __stdcall DllMain(HANDLE hInstance, DWORD dwCallType, LPVOID lpPretendIDontExist)
{
    DWORD dummy;

    if(dwCallType == DLL_PROCESS_ATTACH)
    {
        hInstMain = hInstance;

        //do a bit of hookering
        HMODULE hEngineModule = GetModuleHandle(TEXT("Engine"));

        mainVolumeAddress = (DWORD)GetTrueProcAddress(hEngineModule, "?execSetInstantMusicVolume@AActor@@QAEXAAUFFrame@@QAX@Z");
        DWORD jumpAddress = (DWORD)PreSetMusicVolume;

        VirtualProtect((LPVOID)mainVolumeAddress, 5, PAGE_EXECUTE_READWRITE, &dummy);
        appMemcpy(oldHookData, (LPVOID)mainVolumeAddress, 5);

        DWORD jumpOffset = jumpAddress - (mainVolumeAddress+5);

        newHookData[0] = 0xE9;
        *(LPDWORD)(&newHookData[1]) = jumpOffset;

        oggPath = GConfig->GetStr(TEXT("Core.System"), TEXT("OggPath"));

        if(!oggPath.Len())
        {
            oggPath = TEXT("..\\Music\\Ogg\\");
        }
        else
        {
            TCHAR *lpWhatever = (TCHAR*)oggPath.GetCharArray().GetData(); //I shouldn't have to do this tim sweeny.

            DWORD lastChar = wcslen(lpWhatever);

            for(DWORD i=0; i<lastChar; i++)
            {
                if(lpWhatever[i] == '/')
                    lpWhatever[i] = '\\';
            }

            if(lpWhatever[lastChar] != '\\')
                oggPath += TEXT("\\");
        }

        __asm nop;

        //  Okay okay.  What I did was take the original Engine::SetInstantMusicVolume
        //function, and 'hook' it.  What I mean by that is make it so that whenever
        //it's called, it jumps streight to -my- function instead.  SetMusicVolume.
    }
    else if(dwCallType == DLL_PROCESS_DETACH)
    {
        //here we set things back to normal.
        appMemcpy((LPBYTE)mainVolumeAddress, oldHookData, 5);
    }

    return TRUE;
}

ADXOgg::ADXOgg()
{
    ++dwClassRefs;

    //hook the volume function
    if(dwClassRefs == 1)
    {
        bDirectSoundInitialized = InitDirectSound();

        if(!bFoundWindow)
            bArghIHaveToWaitForTheWindowToOpenBeforeICanDoAnythingIBlameTimSweenyOrCarone = TRUE;

        appMemcpy((LPVOID)mainVolumeAddress, newHookData, 5);

        INT value = 0.0f;
        GConfig->GetInt(TEXT("Galaxy.GalaxyAudioSubsystem"), TEXT("MusicVolume"), value);
        GlobalMusicVolume = float(value)/255.0f;
    }
}

void ADXOgg::Destroy()
{
    --dwClassRefs;

    //unhook the volume function
    if(!dwClassRefs)
    {
        if(bDirectSoundInitialized)
        {
            if(currentStream)
            {
                delete currentStream;
                currentStream = NULL;
            }

            appMemcpy((LPBYTE)mainVolumeAddress, oldHookData, 5);

            DestroyDirectSound();
        }
    }

    Super::Destroy();
}

UBOOL ADXOgg::Tick(FLOAT fTime, ELevelTick TickType)
{
    UBOOL ret;

    ret = Super::Tick(fTime, TickType);

    if(bArghIHaveToWaitForTheWindowToOpenBeforeICanDoAnythingIBlameTimSweenyOrCarone)
    {
        if(bDirectSoundInitialized = InitDirectSound())
        {
            bArghIHaveToWaitForTheWindowToOpenBeforeICanDoAnythingIBlameTimSweenyOrCarone = FALSE;
        }
    }

    if(bDirectSoundInitialized && bWaitingToPlaySong)
    {
        delete currentStream;
        currentStream = new OggStream((TCHAR*)nextOggFileIntro.GetCharArray().GetData(),
                                      (TCHAR*)nextOggFileLoop.GetCharArray().GetData());
        currentStream->Play(nextPlayPos);

        bWaitingToPlaySong = FALSE;
    }

    if(!bDirectSoundInitialized)
        return ret;

    if(currentStream)
    {
        if(bFadingIn)
        {
            if(transitionTime < transitionSpeed)
            {
                FLOAT fVolAdjust = fTime/transitionSpeed;
                transitionTime += fTime;

                float fVolume = currentStream->GetVolume();
                float newVolume = (fVolume+fVolAdjust);

                if( (transitionTime > transitionSpeed)  ||
                    (newVolume > 1.0f)                  )
                {
                    currentStream->SetVolume(1.0f);

                    transitionTime = transitionSpeed = 0.0f;
                    bFadingIn = FALSE;
                }
                else
                    currentStream->SetVolume(newVolume);
            }
        }
        else
        {
            if(transitionTime > 1e-04f)
            {
                FLOAT fVolAdjust = fTime/transitionSpeed;
                transitionTime -= fTime;

                float fVolume = currentStream->GetVolume();
                float newVolume = (fVolume-fVolAdjust);

                if( (newVolume < 0.0f)        ||
                    (transitionTime < 1e-04f) )
                {
                    delete currentStream;
                    currentStream = new OggStream((TCHAR*)nextOggFileIntro.GetCharArray().GetData(),
                                                  (TCHAR*)nextOggFileLoop.GetCharArray().GetData());

                    //if the play position isn't at the beginning, do a fade in
                    //so it feels more smooth
                    if(nextPlayPos != 0.0)
                    {
                        currentStream->SetVolume(0.0f);

                        transitionTime = 0.0f;
                        transitionSpeed *= 0.5f;

                        bFadingIn = TRUE;
                    }

                    currentStream->Play(nextPlayPos);
                }
                else
                    currentStream->SetVolume(newVolume);
            }
        }
    }

    return ret;
}

//object pointer backup
DWORD curObject;

__declspec(naked) void PreSetMusicVolume()
{
    __asm
    {
        mov curObject, ecx
        jmp SetMusicVolume
    }
}

void __stdcall SetMusicVolume(FFrame* Stack, RESULT_DECL)
{
    BYTE* Pos = Stack->Code;
    BYTE volume = 0;
    Stack->Step(Stack->Object, &volume);
    Stack->Code = Pos;

    appMemcpy((LPBYTE)mainVolumeAddress, oldHookData, 5);

    __asm
    {
        push ecx

        push Result
        push Stack
        mov ecx, curObject
        call mainVolumeAddress

        pop ecx
    }

    appMemcpy((LPVOID)mainVolumeAddress, newHookData, 5);

    GlobalMusicVolume = float(volume)/255.0f;

    if(bDirectSoundInitialized)
    {
        if(currentStream)
            currentStream->ResetVolume();
    }
}

void ADXOgg::execSetCurrentOgg(FFrame& Stack, RESULT_DECL)
{
    P_GET_STR(strOggFileIntro);
    P_GET_STR(strOggFileLoop);
    P_GET_INT(playPos);
    P_GET_INT(transition);
    P_FINISH;

    if(bDirectSoundInitialized || bArghIHaveToWaitForTheWindowToOpenBeforeICanDoAnythingIBlameTimSweenyOrCarone)
    {
        if(currentStream && (currentStream->fileName == strOggFileLoop))
            return;

        //----------------------------------------

        FString path = oggPath;
        path += strOggFileLoop;

        WIN32_FIND_DATA wfd;
        TCHAR *lpPath = (TCHAR*)path.GetCharArray().GetData();
        HANDLE hFound = FindFirstFile(lpPath, &wfd);

        if(hFound == INVALID_HANDLE_VALUE)
        {
            debugf(TEXT("DXOgg: Could not find Ogg File: '%s'"), (TCHAR*)lpPath);
            return;
        }

        FindClose(hFound);

        //----------------------------------------

        TCHAR *lpWhatever = (TCHAR*)strOggFileIntro.GetCharArray().GetData();
        if(strOggFileIntro.Len() && lpWhatever[0])
        {
            path = oggPath;
            path += strOggFileLoop;

            hFound = FindFirstFile((TCHAR*)path.GetCharArray().GetData(), &wfd);

            if(hFound == INVALID_HANDLE_VALUE)
            {
                debugf(TEXT("DXOgg: Could not find Ogg File: '%s'"), (TCHAR*)path.GetCharArray().GetData());
                return;
            }

            FindClose(hFound);
        }

        //----------------------------------------

        nextPlayPos = playPos;
        nextOggFileIntro = strOggFileIntro;
        nextOggFileLoop = strOggFileLoop;
        bFadingIn = FALSE;

        if(!currentStream)
            transition = MTRAN_Instant;

        if(bArghIHaveToWaitForTheWindowToOpenBeforeICanDoAnythingIBlameTimSweenyOrCarone)
        {
            bWaitingToPlaySong = TRUE;
            return;
        }

        switch(transition)
        {
            case MTRAN_Instant:
                delete currentStream;
                currentStream = new OggStream((TCHAR*)nextOggFileIntro.GetCharArray().GetData(),
                                              (TCHAR*)nextOggFileLoop.GetCharArray().GetData());
                currentStream->Play(nextPlayPos);
                break;

            case MTRAN_FastFade:
                transitionSpeed = transitionTime = 1.0f;
                break;

            case MTRAN_Fade:
                transitionSpeed = transitionTime = 2.0f;
                break;

            case MTRAN_SlowFade:
                transitionSpeed = transitionTime = 3.0f;
                break;
        }
    }
}

void ADXOgg::execGetCurrentSongPosition(FFrame& Stack, RESULT_DECL)
{
    P_FINISH;

    if(bDirectSoundInitialized)
    {
        if(currentStream)
            *(float*)Result = currentStream->GetCurrentPosition();
    }
}

